float4 vCol;    //bV̐F
float4 vLightDir = {0.0f, 0.0f, -1.0f, 1.0f};    //Cg̕
float  fSize=0.03f;   //֊sp̌W
float4 BlackColor={0,0,0,1};

// spbg
static const int MAX_MATRICES = 26;  //s̐
float4x3    mWorldMatrixArray[MAX_MATRICES];
float4x4    mVP; // r[~vWFNVs;
// -------------------------------------------------------------
// eNX`
// -------------------------------------------------------------
texture DecalTex;
sampler DecalTexSamp = sampler_state
{
    Texture = <DecalTex>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = NONE;

    AddressU = WRAP;
    AddressV = WRAP;
};

texture ToonTex;
sampler ToonTexSamp = sampler_state
{
    Texture = <ToonTex>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = NONE;

    AddressU = CLAMP;
    AddressV = CLAMP;
};

///////////////////////////////////////////////////////
struct VS_INPUT
{
    float4  Pos             : POSITION;
    float4  BlendWeights    : BLENDWEIGHT;
    float4  BlendIndices    : BLENDINDICES;
    float3  Normal          : NORMAL;
    float3  Tex             : TEXCOORD0;
};

//gD[̕`
struct VS_OUTPUT
{
    float4  Pos        : POSITION;
    float4  Diffuse    : COLOR;
    float2  DecaleTex  : TEXCOORD1;
    float2  ToonTexUV  : TEXCOORD0;
};

//֊sp
struct VS_OUTPUT2
{
    float4  Pos        : POSITION;
    float4  Diffuse    : COLOR;
};

//CgxNgƖ@xNgƂ̓ςvZ
float NdotL(float3 Normal)
{
    float CosTheta;
    
    // N.L Clamped
    CosTheta = max(0.0f, dot(Normal, -vLightDir.xyz));
       
    return (CosTheta);
}


VS_OUTPUT ToonShade(VS_INPUT In, uniform int NumBones)
{
    VS_OUTPUT   Out;
    float3      Pos = 0.0f;
    float3      Normal = 0.0f;    
    float       LastWeight = 0.0f;
     
    // Geforce3̂߂̏
    int4 IndexVector = D3DCOLORtoUBYTE4(In.BlendIndices);

    // [vŎg₷邽߂ɗvfP̔z
    // 4ɃLXg
    float BlendWeightsArray[4] = (float[4])In.BlendWeights;
    int   IndexArray[4]        = (int[4])IndexVector;
    
    // ʒuƖ@[hԂ֕ϊ
    // IndexArrayspbgĂ
    for (int iBone = 0; iBone < NumBones-1; iBone++)
    {
        LastWeight = LastWeight + BlendWeightsArray[iBone];
        
        Pos += mul(In.Pos, mWorldMatrixArray[IndexArray[iBone]]) * BlendWeightsArray[iBone];
        Normal += mul(In.Normal, mWorldMatrixArray[IndexArray[iBone]]) * BlendWeightsArray[iBone];
    }

    //Ō̏d݂͌vZ@Ⴄ̂Ń[v̊OŌvZ
    LastWeight = 1.0f - LastWeight; 

    Pos += (mul(In.Pos, mWorldMatrixArray[IndexArray[NumBones-1]]) * LastWeight);
    Normal += (mul(In.Normal, mWorldMatrixArray[IndexArray[NumBones-1]]) * LastWeight); 
    
    // ʒu[hԂˉeԂɕϊ
    Out.Pos = mul(float4(Pos.xyz, 1.0f), mVP);

    //@𐳋K
    Normal = normalize(Normal);

    // Shade (Ambient + etc.)
    Out.Diffuse = vCol;

    // gD[pUVl
    Out.ToonTexUV.xy = (dot(-vLightDir, Normal)+1)*0.5f;

    // copy the input texture coordinate through
    Out.DecaleTex  = In.Tex;

    return Out;
}


//֊s̕`
VS_OUTPUT2 OutLine(VS_INPUT In, uniform int NumBones)
{
    VS_OUTPUT2  Out=(VS_OUTPUT2)0;
    float3      Pos = 0.0f;
    float3      Normal = 0.0f;    
    float       LastWeight = 0.0f;
     
    // Geforce3̂߂̏
    int4 IndexVector = D3DCOLORtoUBYTE4(In.BlendIndices);

    // [vŎg₷邽߂ɗvfP̔z
    // 4ɃLXg
    float BlendWeightsArray[4] = (float[4])In.BlendWeights;
    int   IndexArray[4]        = (int[4])IndexVector;
    
    // ʒuƖ@[hԂ֕ϊ
    // IndexArrayspbgĂ
    for (int iBone = 0; iBone < NumBones-1; iBone++)
    {
        LastWeight = LastWeight + BlendWeightsArray[iBone];
        
        Pos += mul(In.Pos, mWorldMatrixArray[IndexArray[iBone]]) * BlendWeightsArray[iBone];
        Normal += mul(In.Normal, mWorldMatrixArray[IndexArray[iBone]]) * BlendWeightsArray[iBone];
    }

    //Ō̏d݂͌vZ@Ⴄ̂Ń[v̊OŌvZ
    LastWeight = 1.0f - LastWeight; 

    Pos += (mul(In.Pos, mWorldMatrixArray[IndexArray[NumBones-1]]) * LastWeight);
    Normal += (mul(In.Normal, mWorldMatrixArray[IndexArray[NumBones-1]]) * LastWeight); 
    
    //@ˉeԂɕϊ(w0ɂĒu)
    float4 n = mul(float4(Normal.xyz, 0.0f), mVP);

    //@𐳋K
    n = normalize(n);
    n.z = 0;

    // ʒu[hԂˉeԂɕϊ
    // @ɉo
    Out.Pos = mul(float4(Pos.xyz, 1.0f), mVP)+fSize*n;

    // Shade (Ambient + etc.)
    Out.Diffuse = BlackColor;

    return Out;
}


VS_OUTPUT2 ShadowModel(VS_INPUT In, uniform int NumBones)
{
    VS_OUTPUT2  Out;
    float3      Pos = 0.0f;
    float       LastWeight = 0.0f;
     
    // Geforce3̂߂̏
    int4 IndexVector = D3DCOLORtoUBYTE4(In.BlendIndices);

    // [vŎg₷邽߂ɗvfP̔z
    // 4ɃLXg
    float BlendWeightsArray[4] = (float[4])In.BlendWeights;
    int   IndexArray[4]        = (int[4])IndexVector;
    
    // ʒuƖ@[hԂ֕ϊ
    // IndexArrayspbgĂ
    for (int iBone = 0; iBone < NumBones-1; iBone++)
    {
        LastWeight = LastWeight + BlendWeightsArray[iBone];
        Pos += mul(In.Pos, mWorldMatrixArray[IndexArray[iBone]]) * BlendWeightsArray[iBone];
    }

    //Ō̏d݂͌vZ@Ⴄ̂Ń[v̊OŌvZ
    LastWeight = 1.0f - LastWeight; 

    Pos += (mul(In.Pos, mWorldMatrixArray[IndexArray[NumBones-1]]) * LastWeight);
    
    // ʒu[hԂˉeԂɕϊ
    Out.Pos = mul(float4(Pos.xyz, 1.0f), mVP);

    // Shade (Ambient + etc.)
    Out.Diffuse = BlackColor;

    return Out;
}

int CurNumBones = 2;

VertexShader toonArray[4] ={ compile vs_1_1 ToonShade(1), 
                            compile vs_1_1 ToonShade(2),
                            compile vs_1_1 ToonShade(3),
                            compile vs_1_1 ToonShade(4)
                          };


VertexShader outlineArray[4] = { compile vs_1_1 OutLine(1), 
                            compile vs_1_1 OutLine(2),
                            compile vs_1_1 OutLine(3),
                            compile vs_1_1 OutLine(4)
                          };


VertexShader shadowArray[4] = { compile vs_1_1 ShadowModel(1), 
                            compile vs_1_1 ShadowModel(2),
                            compile vs_1_1 ShadowModel(3),
                            compile vs_1_1 ShadowModel(4)
                          };


//////////////////////////////////////
// Techniques specs follow
//////////////////////////////////////
technique TShader
{
    pass p0
    {
        VertexShader = (toonArray[CurNumBones]);
    }
    pass p1
    {
        VertexShader = (outlineArray[CurNumBones]);
    }
    pass p2
    {
        VertexShader = (shadowArray[CurNumBones]);
    }
}

